/* LS7166 APPLICATION NOTE, EXAMPLE PROVIDED FOR REFERENCE BY */
/* U.S. Digital Corp (206) 260-7451                   3-11-93 */
/* note: pin 3 and pin 4 are normally high, pin 18 to address 0 */
/* Borland C source code */

#include <stdio.h>             
#include <dos.h>
#include <conio.h>

/* addresses */
#define BASE          0X300		// base address of interface board
#define DATA1         BASE+0	// data register of LS7166
#define CONTROL1      BASE+1	// control register of LS7166
#define LOAD          BASE+8	// a write toggles pin 3 of LS7166

/* LS7166 commands */
#define MASTER_RESET  0X20		// master reset command
#define INPUT_SETUP   0X68		// setup counter input mode
#define QUAD_X1       0XC1		// quadrature multiplier to 1
#define QUAD_X2       0XC2		// quadrature multiplier to 2
#define QUAD_X4       0XC3		// quadrature multiplier to 4
#define ADDR_RESET    0X01		// reset address pointer
#define LATCH_CNTR    0X02		// latch counter
#define CNTR_RESET    0X04		// reset counter
#define PRESET_CTR    0X08		// transfer preset to counter

void init(void) {       			/* initialize the 7166 */
  outportb(CONTROL1, MASTER_RESET);
  outportb(CONTROL1, INPUT_SETUP);
  outportb(CONTROL1, QUAD_X4);
  outportb(CONTROL1, CNTR_RESET);

  /* preset counter to 44 */
  outportb(CONTROL1, ADDR_RESET);	// reset addr
	outportb(DATA1, 0x44);					// output preset value
	outportb(DATA1, 0x0);						// output preset value
	outportb(DATA1, 0x0);						// output preset value
  outportb(CONTROL1, PRESET_CTR);	// preset to counter
}

void soft_latch(void) {  					// latch position with software command
  outportb(CONTROL1, LATCH_CNTR);	// counter to latch
}

void hard_latch(void) {  					// latch position with low pulse on pin 3
	outportb(LOAD, 0);              // toggle pin 3 of LS 7166
}

long read_position(void) {  			// read position of encoder
  long position;
	outportb(CONTROL1, ADDR_RESET);	// reset address pointer
  position  = (long)inportb(DATA1);      // least significant byte
  position += (long)inportb(DATA1) << 8;
  position += (long)inportb(DATA1) <<16; // most significant byte
  return position;
}

void main(void) {
  init();
	while (!kbhit()) {
    soft_latch();
		printf("\n position =%8lX", read_position());
} }
